-- Test add_services_carousel_slide
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(14);

set search_path to camper, public;

select has_function('camper', 'add_services_carousel_slide', array['integer', 'text']);
select function_lang_is('camper', 'add_services_carousel_slide', array['integer', 'text'], 'sql');
select function_returns('camper', 'add_services_carousel_slide', array['integer', 'text'], 'integer');
select isnt_definer('camper', 'add_services_carousel_slide', array['integer', 'text']);
select volatility_is('camper', 'add_services_carousel_slide', array['integer', 'text'], 'volatile');
select function_privs_are('camper', 'add_services_carousel_slide', array['integer', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'add_services_carousel_slide', array['integer', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'add_services_carousel_slide', array['integer', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'add_services_carousel_slide', array['integer', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate services_carousel_i18n cascade;
truncate services_carousel cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('text/plain', 'hello, world!')
     , ('image/svg+xml', '<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (5, 1, 'text.txt', sha256('hello, world!'))
     , (6, 1, 'image.svg', sha256('<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>'))
     , (7, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into services_carousel (media_id, caption)
values (5, 'Previous caption')
;

select lives_ok(
	$$ select add_services_carousel_slide(6, 'A caption') $$,
	'Should be able to add a carousel slide with a caption'
);

select lives_ok(
	$$ select add_services_carousel_slide(7, null) $$,
	'Should be able to add a carousel slide without caption'
);

select lives_ok(
	$$ select add_services_carousel_slide(5, 'New caption') $$,
	'Should be able to overwrite a slide with a new caption'
);

select bag_eq(
	$$ select media_id, caption from services_carousel $$,
	$$ values (5, 'New caption')
	        , (6, 'A caption')
	        , (7, '')
	$$,
	'Should have all three slides'
);

select is_empty(
	$$ select * from services_carousel_i18n $$,
	'Should not have added any translation'
);


select *
from finish();

rollback;
